#type vertex
#version 330 core
layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aTexCoords;

out vec3 Position;
out vec3 Normal;
out vec2 TexCoords;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;


void main() {
Position = vec3(model * vec4(aPos, 1.0));
Normal = mat3(transpose(inverse(model))) * aNormal;
TexCoords = aTexCoords;
gl_Position = projection * view * vec4(Position, 1.0);
}

#type fragment
#version 330 core
out vec4 FragColor;

in vec3 Position;
in vec3 Normal;
in vec2 TexCoords;

uniform vec3 cameraPos;
uniform float envInfluence;
uniform samplerCube environment;

void main() {
vec3 I = normalize(Position - cameraPos);
vec3 R = reflect(I, normalize(Normal));

FragColor = mix(vec4(1,1,1,1), vec4(texture(environment, R).rgb,1.0), envInfluence);

}